// finish this file
#ifndef LINKEDLIST_H
#define LINKEDLIST_H
#include <iostream>
using namespace std;
template <typename myType>
struct nodeType
{
    myType info;
    nodeType<myType>*link;
};

template <typename myType>
class linkedListType
{
    protected:
        int count = 0;
        nodeType<myType>* first;
        nodeType<myType>* last;
    public:
        linkedListType();
        linkedListType(linkedListType<myType> &list);
        ~linkedListType();
        void initializeList();
        const bool isEmptyList();
        const void print();
        const void reversePrint();
        const int length();
        void destroyList();
        const myType front();
        const myType back();
        nodeType<myType>*firstPtr();
        void copyList(const linkedListType<myType>&);
        const void recursiveReversePrint(nodeType<myType> *);
        virtual const bool search(const myType &) = 0;
        virtual void insert(const myType &) = 0;
        virtual void insertLast(const myType &) = 0;
        virtual void deleteNode(const myType &) = 0;
};

template<typename myType>
linkedListType<myType>::linkedListType()
{
    first=NULL;
    last=NULL;
    count=0;
}
template<typename myType>
linkedListType<myType>::~linkedListType() 
{
    nodeType<myType>* first=first;
    while(first!=NULL)
    {
        nodeType<myType>* currentNode=first;
        first=first->link;
        delete currentNode;
    }
}

template<typename myType>
void linkedListType<myType>::initializeList(void)
{
    first = last = NULL;
    count = 0;
}

template<typename myType>
const bool linkedListType<myType>::isEmptyList(void)
{
    return first==NULL;
}

template<typename myType>
const void linkedListType<myType>::print(void)
{
    nodeType<myType>* currentNode=first;
    while(currentNode!=NULL)
    {
        cout<<currentNode->info<<" ";
        currentNode=currentNode->link;
    }
    return;
}

template<typename myType>
const void linkedListType<myType>::reversePrint(void)
{
    recursiveReversePrint(first);
    return;
}

template<typename myType>
const void linkedListType<myType>::recursiveReversePrint(nodeType<myType> *head)
{
    if (head == NULL) 
        return; 
    recursiveReversePrint(head->link); 
    cout << head->info << " ";
}

template<typename myType>
const int linkedListType<myType>::length(void)
{
    return count;
}

template<typename myType>
void linkedListType<myType>::destroyList(void)
{
    first = last = NULL;
    count = 0;
    return;
}

template<typename myType>
const myType linkedListType<myType>::front(void)
{
    if(!first)
        return 0;
    return first->info;
}

template<typename myType>
const myType linkedListType<myType>::back(void)
{
    if(!first)
        return 0;
    return last->info;
}


template<typename myType>
linkedListType<myType>::linkedListType(linkedListType<myType> &list)
{
    nodeType<myType>*temp = list.first;
    first = last = NULL;
    while(temp)
    {
        nodeType<myType>*newnode = new nodeType<myType>();
        newnode->info = temp->info;
        if(!first)
        {
            first = last = newnode;
        }
        else
        {
            last ->link = newnode;
            last = newnode;
        }
        count++;
        temp = temp->link;
    }
}

template<typename myType>
void linkedListType<myType>::copyList(const linkedListType<myType> &list)
{
    first = list.first;
    return;
}

#endif
