// finish this file

#ifndef ORDEREDLINKEDLIST_H
#define ORDEREDLINKEDLIST_H
#include <iostream>
#include "linkedListType.h"
using namespace std;

template <typename myType>
class orderedLinkedList : public linkedListType<myType>
{
    public:
        using linkedListType<myType>::count;
        using linkedListType<myType>::first;
        using linkedListType<myType>::last;
        const bool search(const myType &);
        virtual void insert(const myType &);
        virtual void insertLast(const myType &);
        virtual void deleteNode(const myType &);
};

template <typename myType>
const bool orderedLinkedList<myType>::search(const myType &val)
{
    nodeType<myType>* temp = first;
    while(temp != NULL) {
        if(temp->info == val)
            return true;
        temp = temp->link;
    }
    return false;
}

template <typename myType>
void orderedLinkedList<myType>::insert(const myType &val)
{
    nodeType<myType>* new_node = new nodeType<myType>();
    new_node->info = val;
    last = new_node;
    nodeType<myType>* current;
    if (first == NULL || (first)->info >= new_node->info) 
    {
        new_node->link = first;
        first = new_node;
    }
    else 
    {
        current = first;
        while (current->link != NULL && current->link->info < new_node->info) 
        {
            current = current->link;
        }
        new_node->link = current->link;
        current->link = new_node;
    }
    count++;
}


template <typename myType>
void orderedLinkedList<myType>::insertLast(const myType &val)
{
    nodeType<myType>* new_node = new nodeType<myType>();
    new_node->info = val;
    last = new_node;
    nodeType<myType>* current;
    if (first == NULL || (first)->info >= new_node->info) 
    {
        new_node->link = first;
        first = new_node;
    }
    else
    {
        current = first;
        while (current->link != NULL && current->link->info < new_node->info) 
        {
            current = current->link;
        }
        new_node->link = current->link;
        current->link = new_node;
    }
    count++;
}
template<typename myType>
void orderedLinkedList<myType>::deleteNode(const myType &val)
{
    if(first==NULL)
    {
        cout<<"Cannot delete from an empty list.\n";
        return;
    }
    nodeType<myType>* temp = first;
    bool check = false;
    while(temp)
    {
        if(temp->info==val)
        {
            break;
        }
        temp = temp->link;
    }
    if(!temp)
    {
        cout<<"The item to be deleted is not in the list.\n";
        return;
    }
    nodeType<myType>* prev = NULL;
    if (temp != NULL && temp->info == val)
    {
        first = temp->link;
        delete temp;
    }
    else
    {
        while (temp != NULL && temp->info != val)
        {
            prev = temp;
            temp = temp->link;
        }
        if (temp == NULL)
            return;
        prev->link = temp->link;
        delete temp;
    }
    temp = first;
    while(temp && temp->link)
    {
        temp = temp->link;
    }
    last = temp;
    count--;
    return;
}

#endif
