// finish this file

#ifndef UNORDEREDLINKEDLIST_H
#define UNORDEREDLINKEDLIST_H
#include <iostream>
#include "linkedListType.h"
using namespace std;

template <typename myType>
class unorderedLinkedList : public linkedListType<myType>
{
    protected:
        using linkedListType<myType>::count;
        using linkedListType<myType>::first;
        using linkedListType<myType>::last;
    public:
        const bool search(const myType &);
        virtual void insert(const myType &);
        virtual void insertLast(const myType &);
        virtual void deleteNode(const myType &);
};
template <typename myType>
const bool unorderedLinkedList<myType>::search(const myType &val)
{
    nodeType<myType>* temp = first;
    while(temp != NULL) {
        if(temp->info == val)
            return true;
        temp = temp->link;
    }
    return false;
}

template <typename myType>
void unorderedLinkedList<myType>::insert(const myType &val)
{
    nodeType<myType>* start = new nodeType<myType>();
    start->info = val;
    if(first==NULL)
    {
        start->link = NULL;
        first=start;
        last=start;
        count++;
    }
    else
    {
        last->link = start;
        last = start;
        count++;
    }
    return;
}
template <typename myType>
void unorderedLinkedList<myType>::insertLast(const myType &val)
{
    nodeType<myType>* start = new nodeType<myType>();
    start->info = val;
    if(first==NULL)
    {
        start->link = NULL;
        first=start;
        last=start;
        count++;
    }
    else
    {
        last->link = start;
        last = start;
        count++;
    }
    return;
}
template<typename myType>
void unorderedLinkedList<myType>::deleteNode(const myType &val)
{
    if(first==NULL)
    {
        cout<<"Cannot delete from an empty list.\n";
        return;
    }
    nodeType<myType>* temp = first;
    bool check = false;
    while(temp)
    {
        if(temp->info==val)
        {
            break;
        }
        temp = temp->link;
    }
    if(!temp)
    {
        cout<<"The item to be deleted is not in the list.\n";
        return;
    }
    nodeType<myType>* prev = NULL;
    if (temp != NULL && temp->info == val)
    {
        first = temp->link;
        delete temp;
    }
    else
    {
        while (temp != NULL && temp->info != val)
        {
            prev = temp;
            temp = temp->link;
        }
        if (temp == NULL)
            return;
        prev->link = temp->link;
        delete temp;
    }
    temp = first;
    while(temp && temp->link)
    {
        temp = temp->link;
    }
    last = temp;
    count--;
    return;
}

#endif
